src/mydjango/urls.py
from django.conf.urls import url
from django.contrib import admin
from django.conf.urls.static import static
from django.conf import settings
from django.urls import include, path
from django.contrib.auth.decorators import login_required
from myapp.views import ShowHome
from myapp.views import ShowVolume
from myapp.views import ShowSearch
from myapp.views import ShowAnnotate
from myapp.views import ShowPersons, ShowOrganisations, ShowPlaces, ShowTerms, ShowNotebooks
from myapp.views import ShowBatches, ShowEntity, pull_entity_network
from myapp.views import ShowBatch, add_page_to_batch, remove_page_from_batch, page_in_batch, set_current_batch, export_batch, export_batch_en, export_batch_as_jsonl, export_batch_entities
from myapp.views import DeleteBatch

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^$', ShowHome.as_view()),
    url(r'^search/', ShowSearch.as_view()),
    url(r'^delete/(?P<pk>\d+)/$', DeleteBatch.as_view(),name='delete_batch'),
    url(r'^export_batch_en/(?P<pk>\d+)/$', export_batch_en,name='export_batch_en'),
    url(r'^export_batch/(?P<pk>\d+)/$', export_batch,name='export_batch'),
    url(r'^export_as_jsonl/(?P<pk>\d+)/$', export_batch_as_jsonl,name='export_as_jsonl'),
    url(r'^export_batch_entities/(?P<pk>\d+)/$', export_batch_entities,name='export_batch_entities'),
    url(r'^persons/', login_required(ShowPersons.as_view())),
    url(r'^terms/', login_required(ShowTerms.as_view())),
    url(r'^organisations/', login_required(ShowOrganisations.as_view())),
    url(r'^places/', login_required(ShowPlaces.as_view())),
    path('volumes/<int:pk>/', ShowVolume.as_view(), name='show_volume'),
    path('batches/', login_required(ShowBatches.as_view()), name='show_batches'),
    path('notebooks/', login_required(ShowNotebooks.as_view()), name='show_notebooks'),
    path('annotate/<str:language>', login_required(ShowAnnotate.as_view()), name='annnotate'),
    path('batches/<int:pk>/', login_required(ShowBatch.as_view()), name='show_batch'),
    path('entities/<int:pk>/<str:menu_item>', login_required(ShowEntity.as_view()), name='show_entity'),
    path('ajax/entities/<int:pk>/pull_network', pull_entity_network, name='pull_entity_network'),
    path('ajax/batches/<int:batch_id>/add_page/<int:page_id>', add_page_to_batch, name='add_page_to_batch'),
    path('ajax/batches/<int:batch_id>/remove_page/<int:page_id>', remove_page_from_batch, name='remove_page_from_batch'),
    path('ajax/batches/<int:batch_id>/set_current', set_current_batch, name='set_current_batch'),
    path('ajax/batches/<int:batch_id>/page_in_batch/<int:page_id>', page_in_batch, name='page_in_batch'),
    path('accounts/', include('django.contrib.auth.urls')),
]
# urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
# urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

if settings.DEBUG:
    import debug_toolbar
    urlpatterns = [
        path('__debug__/', include(debug_toolbar.urls)),

        # For django versions before 2.0:
        # url(r'^__debug__/', include(debug_toolbar.urls)),

    ] + urlpatterns

src/myapp/models.py
from django.contrib.postgres.fields import ArrayField, JSONField
from polymorphic.models import PolymorphicModel
from django.db import models
from django.db.models import Count
from django.contrib.postgres.indexes import GinIndex
from django.contrib.auth.models import User
import django.contrib.postgres.search as pg_search
import spacy
from spacy.tokens import Doc
from spacy.vocab import Vocab

def get_default_data():
    return { }
    
class Volume(models.Model):
    name = models.CharField(max_length = 512)
    text = models.TextField()
    metadata = JSONField()
    key = models.CharField(max_length = 512, null=True)
    ld_identifier = models.CharField(max_length = 512)
    metadata = JSONField(default=get_default_data)
    link = models.CharField(max_length = 512)
    start_date = models.DateField(null=True, db_index=True)
    end_date = models.DateField(null=True, db_index=True)
    attendees = models.ManyToManyField('Attendee', through='AttendanceEvent')

    def start_year():
        return start_date.strftime('%Y')
    def end_year():
        return end_date.strftime('%Y')

    def __str__(self):
        return self.name

    def get_absolute_url(self):
        from django.urls import reverse
        return reverse('show_volume', args=[self.pk])
    class Meta:
        ordering = ['start_date']
    
            

class Page(models.Model):
    name = models.CharField(max_length = 512)
    page_identifier = models.CharField(max_length = 512)
    ld_identifier = models.CharField(max_length = 512)
    page_index = models.IntegerField(blank=True)
    metadata = JSONField(null=True)
    section_type = models.CharField(max_length = 512, null = True, db_index = True)
    language = models.CharField(max_length = 5, null = True, db_index = True)
    language_confidence =models.DecimalField(max_digits=4, decimal_places=2, null=True)
    feature = models.CharField(max_length = 512, null = True, db_index = True)
    spacy_doc = models.BinaryField(null=True)
    spacy_vocab = models.BinaryField(null=True)
    sentences = JSONField(null=True)
    text = models.TextField()
    lemmatized_text = models.TextField()
    stemmed_text = models.TextField()
    tokens = ArrayField(models.CharField(max_length=512), null=True)
    bow_text = models.TextField()
    sv = pg_search.SearchVectorField(null=True)
    class Meta:
        indexes = [GinIndex(fields=['sv'])]
        ordering = ['pk', 'page_identifier']
    metadata = JSONField(default=get_default_data)
    volume = models.ForeignKey(Volume, on_delete=models.PROTECT)
    entities = models.ManyToManyField('Entity', through='Mention')

    def doc(self):
        nlp = spacy.load("./trained/")
        doc = nlp(self.text)
        return doc

    def __str__(self):
        composed_name = self.volume.name
        composed_name = composed_name + '\n'
        composed_name = composed_name +'page '+ self.page_identifier
        return composed_name
    
    def iiif_url(self):
        return f"https://digilib.mpiwg-berlin.mpg.de/digitallibrary/digilib.html?fn=permanent/measuring_the_earth/{self.volume.name}/{self.page_identifier}.jpg"

class Entity(PolymorphicModel):
    name = models.CharField(max_length = 512)
    text = models.TextField()
    metadata = JSONField(default=get_default_data)
    language = models.CharField(max_length = 5, null = True, db_index = True)
    sv = pg_search.SearchVectorField(null=True)
    pages = models.ManyToManyField(Page, through='Mention')
    class Meta:
        indexes = [GinIndex(fields=['sv'])]
        ordering = ['pk', 'text']
    def __str__(self):
        return self.text
    def term_type(self):
        return self.__class__.__name__
    def merge_with(self, source_entity):
        for mention in self.mention_set.all():
            mention.entity = source_entity
            mention.save()

class Mention(models.Model):
    page = models.ForeignKey(Page, on_delete=models.CASCADE)
    entity = models.ForeignKey(Entity, on_delete=models.CASCADE)
    offset_start = models.IntegerField(null=True)
    offset_end = models.IntegerField(null=True)

class Term(Entity):
    ld_identifier = models.CharField(max_length = 512)

class Organisation(Entity):
    ld_identifier = models.CharField(max_length = 512)

class Person(Entity):
    title = models.CharField(max_length = 256, blank=True)
    first_name = models.CharField(max_length = 512)
    last_name = models.CharField(max_length = 512)
    person_identifier = models.CharField(max_length = 512)
    ld_identifier = models.CharField(max_length = 512)

class Place(Entity):
    ld_identifier = models.CharField(max_length = 512)
    # lat = models.DecimalField(max_digits=9, decimal_places=6, blank=True)
    # long = models.DecimalField(max_digits=9, decimal_places=6, blank=True)
 


# class Sentence(models.Model):
#     name = models.CharField(max_length = 512)
#     sentence_identifier = models.CharField(max_length = 512)
#     ld_identifier = models.CharField(max_length = 512)
#     sentence_index = models.IntegerField(blank=True)
#     metadata = JSONField()
#     text = models.TextField()
#     sv = pg_search.SearchVectorField(null=True) 
#     class Meta:
#         indexes = [GinIndex(fields=['sv'])]
#         ordering = ['pk', 'sentence_identifier']
#     metadata = JSONField(default=get_default_data)
#     page = models.ForeignKey(Volume, on_delete=models.PROTECT)
# 
#     def __str__(self):
#         composed_name = self.volume.name
#         composed_name = composed_name + ' > '
#         composed_name = composed_name + self.page_identifier
#         return composed_name

class Batch(models.Model):
    
    name = models.CharField(max_length = 512)
    ld_identifier = models.CharField(max_length = 512)
    pages = models.ManyToManyField(Page)
    creator = models.ForeignKey(User, on_delete=models.PROTECT)

    def __str__(self):
        return self.name

    def text(self):
        all_text = ""
        for page in self.pages.all():
            all_text += page.text
        return all_text
    def doc(self):
        nlp = spacy.load("./trained/")
        doc = nlp(self.text())
        return doc
    def entities(self):
        entities_array = []
        for page in self.pages.all():
            doc = page.doc()
            for ent in doc.ents:
                entities_array.append(ent)
        return entities_array

class Attendee(models.Model):
    surname = models.CharField(max_length = 512)
    alt_surname = models.CharField(max_length = 512)
    name = models.CharField(max_length = 512)
    function = models.CharField(max_length = 512)
    bio = models.TextField()
    # todo: make relationship to place model instead?
    country = models.CharField(max_length = 512)
    active_since  = models.DateField(null=True, db_index=True)
    active_until = models.DateField(null=True, db_index=True)
    # tolloid wikidata doesn't work for some reason docker?
    wikidata = models.CharField(null=True, max_length = 512)
    volumes = models.ManyToManyField('Volume', through='AttendanceEvent')

    # tolloid attendance = models.ManyToManyField(AttendanceEvent)
    
    def __str__(self):
        return self.name
    class Meta:
        ordering = ['pk', 'surname']

class AttendanceEvent(models.Model):
    attendee = models.ForeignKey(Attendee, on_delete=models.CASCADE)
    volume = models.ForeignKey(Volume, on_delete=models.CASCADE)
    event_year =  models.DateField(null=True, db_index=True)

src/myapp/forms.py
from django import forms
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Submit
from crispy_forms.layout import Field
from .models import Batch, Volume

class BatchForm(forms.ModelForm):
    class Meta:
        model = Batch
        fields = ['name']

    def __init__(self, *args, **kwargs):
        super(BatchForm, self).__init__(*args, **kwargs)
        self.helper = FormHelper()
        self.helper.form_method = 'post'
        self.helper.form_action = '/batches/'
        self.helper.add_input(Submit('', 'Create a new batch'))
        self.fields['name'].required = False
        self.fields['name'].label = "Create a new batch from this selection of pages:"

class SearchForm(forms.Form):
    q = forms.CharField(
        label = 'Query:',
        max_length = 256,
        required = False,
        widget= forms.Textarea(
            attrs={'rows': 2, 'cols': 25}
        )
    )

    def __init__(self, *args, **kwargs):
        super(SearchForm, self).__init__(*args, **kwargs)
        self.helper = FormHelper()
        self.helper.form_method = 'get'
        self.helper.form_action = '/search/'
        self.helper.add_input(Submit('', 'Submit'))

    def save(self, commit=True):
        image = self.cleaned_data.pop('image')
        instance = super().save(commit=True)
        return instance

src/templates/notebooks.html
{% extends 'base.html' %}
{% load app_filters %}
{% block content %}
<div id="page-content-wrapper">
        <iframe class='prodigy' id='prodigy' style='width:100%;height:100%;border:none;margin-top:20px' src='https://jupyter.measuring-the-earth.mpiwg-berlin.mpg.de/tree?'></iframe>
</div>
{% endblock %}

src/templates/organisations.html
{% extends 'base.html' %}
{% load bootstrap_pagination %}
{% block content %}
    <div class="d-flex" id="wrapper">
        {% include "includes/analysis_sidebar.html" %}
    <div id="page-content-wrapper">
    <div class="container-fluid">
        <div class='container' style="margin-top:20px">
            <h2 class='text-center'>{{organisations_count}} Organisations</h2>
            {% if organisations.paginator.num_pages > 1 %}
                {% bootstrap_paginate organisations show_prev_next="false" extra_pagination_classes='justify-content-center' show_first_last="true" range=8 %}
            {% endif %} 
            <p>Organisations detected through NER</p>
            <table class="table">
                <thead>
                <tr>
                    <th scope="col">Text</th>
                    <th scope="col">Pages</th>
                </tr>
                </thead>
                <tbody>
                {% for organisation in organisations %}
                    <tr>
                        <th scope="row"><a href='/entities/{{organisation.pk}}/stats'>{{ organisation }}</a></th>
                        <td>
                            {{organisation.page_set.count }}                      
                        </td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
            {% if organisations.paginator.num_pages > 1 %}
                {% bootstrap_paginate organisations show_prev_next="false" extra_pagination_classes='justify-content-center' show_first_last="true" range=8 %}
            {% endif %} 
        </div>
    </div>
    </div>
{% endblock %}

src/templates/persons.html
{% extends 'base.html' %}
{% load bootstrap_pagination %}
{% block content %}
    <div class="d-flex" id="wrapper">
        {% include "includes/analysis_sidebar.html" %}
    <div id="page-content-wrapper">
    <div class="container-fluid">
        <div class='container' style="margin-top:20px">
            <h2 class='text-center'> {{persons_count}} Persons</h2>
            {% if persons.paginator.num_pages > 1 %}
                {% bootstrap_paginate persons show_prev_next="false" extra_pagination_classes='justify-content-center' show_first_last="true" range=8 %}
            {% endif %} 
            <p>Persons detected through NER</p>
            <table class="table">
                <thead>
                <tr>
                    <th scope="col">Text</th>
                    <th scope="col">Pages</th>
                </tr>
                </thead>
                <tbody>
                {% for person in persons %}
                    <tr>
                        <th scope="row"><a href='/entities/{{person.pk}}/stats'>{{ person }}</a></th>
                        <td>
                            {{ person.page_set.count }}
                            <br>                     
                        </td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
            {% if persons.paginator.num_pages > 1 %}
            {% bootstrap_paginate persons show_prev_next="false" extra_pagination_classes='justify-content-center' show_first_last="true" range=8 %}
            {% endif %} 
        </div>
    </div>
    </div>
{% endblock %}

src/templates/places.html
{% extends 'base.html' %}
{% load bootstrap_pagination %}
{% block content %}
    <div class="d-flex" id="wrapper">
        {% include "includes/analysis_sidebar.html" %}
    <div id="page-content-wrapper">
    <div class="container-fluid">
        <div class='container' style="margin-top:20px">
            <h2 class='text-center'>{{places_count}} Places</h2>
            {% if places.paginator.num_pages > 1 %}
                {% bootstrap_paginate places show_prev_next="false" extra_pagination_classes='justify-content-center' show_first_last="true" range=8 %}
            {% endif %} 
            <p>Places detected through NER</p>
            <table class="table">
                <thead>
                <tr>
                    <th scope="col">Name</th>
                    <th scope="col">Pages</th>
                </tr>
                </thead>
                <tbody>
                {% for place in places %}
                    <tr>
                        <th scope="row"><a href='/entities/{{place.pk}}/stats'>{{ place }}</a></th>
                        <td>
                            {{place.page_set.count}}                      
                        </td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
            {% if places.paginator.num_pages > 1 %}
                {% bootstrap_paginate places show_prev_next="false" extra_pagination_classes='justify-content-center' show_first_last="true" range=8 %}
            {% endif %} 
        </div>
    </div>
    </div>
{% endblock %}

src/templates/search.html
{% extends 'base.html' %}
{% load bootstrap_pagination %}
{% load widget_tweaks %}
{% load app_filters %}
{% load crispy_forms_tags %}
{% block content %}

<div class="d-flex" id="wrapper">

  <!-- Sidebar -->
  <div class="border-right border-dark bg-light search-wrapper" id="sidebar-wrapper">
    <div class='sidebar-heading'>Search</div>
      <form method="get" action='/search/' id='search-form'>
        <div id="div_id_q" class="form-group">
            <label for="id_q" class="">
                <a href='#' data-toggle="modal" data-target="#helpModal">
                    Query:
                </a>
            </label>
                <div class="">
                    <textarea name="q" cols="25" rows="2" maxlength="256" class="textarea form-control" id="id_q">{{q}}</textarea>                
                </div>  
        </div>
          <p>
              <label for="amount">Volume Date Range:</label>
              <input type="text" class='form-control' name='range' id="range" readonly style="background-color:lightgray">
            </p>
          <div id="slider-range" ></div>
          <hr/>

              <select name='language' class='form-control'>
                <option value="" {% if selected_language == '' %}selected{% endif %}>Any language</option>
                {% for language in languages %}
                  <option value="{{language}}" {% if language == selected_language %}selected{% endif %}>{{language|language_name}}</option>
                    {% endfor %}
                  </select>
          <hr/>
                  <select name='section_type' class='form-control'>
                    <option value="" {% if section_type == '' %}selected{% endif %}>Any section type</option>
                    {% for section_type in section_types %}
                      {% if section_type != None %}
                          <option value="{{section_type}}" {% if section_type == selected_section_type %}selected{% endif %}>{{section_type}}</option>
                      {% endif %}
                      {% endfor %}
                      </select>
                      <hr/>
                      <select name='feature' class='form-control'>
                        <option value="" {% if feature == '' %}selected{% endif %}>Any feature</option>
                        {% for feature in features %}
                          {% if feature != None %}
                            <option value="{{feature}}" {% if feature == selected_feature %}selected{% endif %}>{{feature}}</option>
                          {% endif %}
                          {% endfor %}
                        </select>
          

          <p>
<!--             <div class="form-check">
              <input type="checkbox" class="form-check-input" id="persons" value="organisations">
              <label class="form-check-label" for="persons">Persons</label>
            </div>
            <div class="form-check">
              <input type="checkbox" class="form-check-input" id="organisations" value="organisations">
              <label class="form-check-label" for="organisations">Organisations</label>
            </div>
            <div class="form-check">
              <input type="checkbox" class="form-check-input" id="places" value="places">
              <label class="form-check-label" for="places">Places</label>
            </div> -->
          </p>
          <button type="submit" class="btn btn-success btn-block"><i class="fas fa-search mr-2"></i>Search</button>
        </form>
        <hr/>
        {% if user.is_authenticated %}
        <div class='sidebar-heading' style='margin-top:-8px'> Batches</div>
        {% if batches.count > 0 %}
        <form>
          <div class='form-group'>
            <label>Current Batch:</label>
            <select class="form-control" id="current-batch">
              {% for batch in batches %}
                <option value="{{batch.id}}"
                {% if batch == current_batch %}selected="selected"{% endif %}>{{batch}}</option>
              {% endfor %}
            </select>
          </div>
          {% endif %}
      </form>
      {% endif %}
      {% if user.is_authenticated %}
        <form method='post' action='/batches/' target="_blank" style="margin-top:-30px">
          {{ batch_form.name|as_crispy_field }}
          {% csrf_token %}
          <input type='hidden' name='es_query' value='{{es_query}}'>
          <button type="submit" class="btn btn-primary btn-block">Create new batch</button>
        </form>
      {% endif %}

  </div>
  <div id="page-content-wrapper">
    <div class="container-fluid">
        <div class="mt-3">
          {% if results_count > 0 %}
          <h3 class='text-center'>Search results</h3>  
            <h5 class='text-center'>{{ results_count }} pages found</h5>  
            {% if results.paginator.num_pages > 1 %}
              {% bootstrap_paginate results show_prev_next="false" extra_pagination_classes='justify-content-center' show_first_last="true" range=8 %}
            {% endif %}
            {% for result in results %}
              <hr/>
              <a class='text-small float-right mr-4 btn btn-sm btn-light' title="view image for this page" href="{{result.iiif_url}}" target="_blank" ><i class="fas fa-file-image mr-2"></i>View image</a>
                  
              <h5><a href="https://digilib.mpiwg-berlin.mpg.de/digitallibrary/jquery/digicat.html?fn=permanent/measuring_the_earth/{{result.volume.name}}" target="_blank">{{ result.volume.name }}</a> > {{ result.page_identifier }}</h5>
              <h6>{{ result.volume_metadata.title }}</h6>
                <p>
                {% for k,v in result.volume_metadata.to_dict.items %}
                    <span class='badge badge-secondary'>{{k}}: {{v}}</span>
                  {% endfor %}
                </p>
                <p>  
                  <span class="badge badge-secondary">language: {{result.language|language_name}} - score: {{result.language_confidence}}</span>
                  <span class="badge badge-secondary">section: {{result.section_type}}</span>
                  <span class="badge badge-secondary">feature: {{result.feature}}</span>
                  {% for key, value in result.metadata.to_dict.items %}
                  <span class="badge badge-secondary">{{key}}: {{value}}</span>
                </p>
              {% endfor %}
              {% if q %}
              {% endif %}
                {% if q %}
                  {{ result.meta.highlight.text.0|safe }}
                {% else %}
                  <p>{{ result.text }}</p>
                  <p>
                    <div class='btn-group'>
                    {% if current_batch %}
                    <a href='#' class='batch-add batch-button btn btn-sm btn-light' id="{{result.id}}" title="add page to current batch"><i class="fas fa-circle-notch fa-spin mr-2"></i> Add to current batch</a>
                    {% endif %}
                  </div>
                  </p>
              {% endif %}
            {% endfor %}
            {% if results.paginator.num_pages > 1 %}
              {% bootstrap_paginate results show_prev_next="false" extra_pagination_classes='justify-content-center' show_first_last="true" range=8 %}
            {% endif %}  
          {% else %}
            <div class="alert alert-primary">
              No results. Please try again!
            </div>
        {% endif %}
  </div>
</div>
    <script>

      function pagesInBatch(){
            $( ".batch-button" ).each(function(index, el) {
              var pageId = $(el).attr('id');
              $(el).html('<i class="fas fa-circle-notch fa-spin mr-2"></i>Loading');
              var batchId = $('#current-batch').val();
              var url = `/ajax/batches/${batchId}/page_in_batch/${pageId}`;
              $.ajax({url: url, context: el, success: function(result){
                if(result['in_batch']){
                  $(this).html('<i class="fas fa-folder-minus mr-2"></i>Remove from current batch');
                  $(this).removeClass('batch-add');
                  $(this).addClass('batch-remove');
                }
                else{
                  $(this).html('<i class="fas fa-folder-plus mr-2"></i>Add to current batch');
                  $(this).removeClass('batch-remove');
                  $(this).addClass('batch-add');                  
                }
              }});
          });
      }

      function submitOnEnter(event){
          if(event.which === 13){
              document.getElementById("search-form").submit();
              event.preventDefault();
          }
      }

      document.getElementById("id_q").addEventListener("keypress", submitOnEnter);

      $(document).ready(function() {
        var checked = $("input[type='checkbox']:checked").length;
        console.log(checked);
        if (checked == 0){ $("input[type='checkbox']").attr('checked','checked')};
  });
  
  $( function() {

    $(document).on('click', '.batch-button', function(e) {
      e.preventDefault();
      $(this).html('<i class="fas fa-circle-notch fa-spin mr-2"></i>Loading');
      var action = 'add';
      if($(this).hasClass('batch-remove')){
        action = 'remove';
      }
      var pageId = $(this).attr('id');
      var batchId = $('#current-batch').val();
      var url = `/ajax/batches/${batchId}/${action}_page/${pageId}`;
      $.ajax({url: url,context: this, success: function(result){
        if(action == 'add'){
          $(this).html('<i class="fas fa-folder-minus mr-2"></i> Remove from current batch');
          $(this).removeClass('batch-add');
          $(this).addClass('batch-remove');
        }else{
          $(this).html('<i class="fas fa-folder-plus mr-2"></i> Add to current batch');
          $(this).removeClass('batch-remove');
          $(this).addClass('batch-add');          
        }
      }});
    });

    $(document).on('change', '#current-batch', function(e) {
      e.preventDefault();
      var batchId = $(this).val();
      $.ajax({url: `/ajax/batches/${batchId}/set_current`,context: this, success: function(result){
          console.log(result)
      }});
      pagesInBatch();
    });

    pagesInBatch();

    $( "#slider-range" ).slider({
      range: true,
      min: {{first_year}},
    max: {{last_year}},
    values: [ {{first_bound}}, {{last_bound}} ],
    step: 1,
      slide: function( event, ui ) {
        $( "#range" ).val(  ui.values[0] + " - " + ui.values[1]  );
      }
    });
    $( "#range" ).val( $( "#slider-range" ).slider( "values", 0 ) +
      " - " + $( "#slider-range" ).slider( "values", 1 ) );
  } );
  </script>

<div class="modal fade" id="helpModal" tabindex="-1" role="dialog" aria-labelledby="helpModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Query Syntax</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
            <p>The following operators are supported:</p><div class="itemizedlist"><ul class="itemizedlist" type="disc"><li class="listitem"><code class="literal">+</code> signifies AND operation</li><li class="listitem"><code class="literal">|</code> signifies OR operation</li><li class="listitem"><code class="literal">-</code> negates a single token</li><li class="listitem"><code class="literal">"</code> wraps a number of tokens to signify a phrase for searching</li><li class="listitem"><code class="literal">*</code> at the end of a term signifies a prefix query</li><li class="listitem"><code class="literal">(</code> and <code class="literal">)</code> signify precedence</li><li class="listitem"><code class="literal">~N</code> after a word signifies edit distance (fuzziness)</li><li class="listitem"><code class="literal">~N</code> after a phrase signifies slop amount (the number of other words permitted between words)</li></ul></div><p>To use one of these characters literally, escape it with a preceding backslash
                (<code class="literal">\</code>).
            </p>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        </div>
      </div>
    </div>
  </div>
    {% endblock %}

src/templates/terms.html
{% extends 'base.html' %}
{% load bootstrap_pagination %}
{% block content %}
    <div class="d-flex" id="wrapper">
        {% include "includes/analysis_sidebar.html" %}
    <div id="page-content-wrapper">
    <div class="container-fluid">
        <div class='container' style="margin-top:20px">
            <h2 class='text-center'>{{terms_count}} Terms</h2>
            {% if terms.paginator.num_pages > 1 %}
                {% bootstrap_paginate terms show_prev_next="false" extra_pagination_classes='justify-content-center' show_first_last="true" range=8 %}
            {% endif %} 
            <p>Geodetical Terms detected through NER</p>
            <table class="table">
                <thead>
                <tr>
                    <th scope="col">Text</th>
                    <th scope="col">Pages</th>
                </tr>
                </thead>
                <tbody>
                {% for term in terms %}
                    <tr>
                        <th scope="row"><a href='/entities/{{term.pk}}/stats'>{{ term }}</a></th>
                        <td>
                            {{ term.page_set.count }}
                            <br>                     
                        </td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
            {% if terms.paginator.num_pages > 1 %}
            {% bootstrap_paginate terms show_prev_next="false" extra_pagination_classes='justify-content-center' show_first_last="true" range=8 %}
            {% endif %} 
        </div>
    </div>
    </div>
{% endblock %}